
#include "StdAfx.h"
#include "make_contrast.h"
#include "write.h"

#include "illa/config.h"

bool CalcContrast()
{
	FILE* f;
	if (fopen_s(&f, "lut_contrast.h", "wb") != 0) return false;
	if (f == 0) return false;

	WriteStartGuard(f, "LUT_CONTRAST_H");

	fprintf(f, "static const unsigned char c_contrast[%i][256]={\n", Img::MaxContrast - Img::MinContrast+1);

	for(int i = Img::MinContrast; i <= Img::MaxContrast; ++i)
	{
		fprintf(f, "\t");
		for(int j=0;j<256;j++) {
			float c = static_cast<float>(i) / 10.0f;
			int val = static_cast<int>(127 + (j - 127) * c);

			if (val < 0)
			{
				val = 0;
			}
			else if (val > 255) 
			{
				val = 255;
			}
			fprintf(f, "%i, ", val);
		}
		fprintf(f, "\n");
	}
	fprintf(f, "};\n\n");

	WriteEndGuard(f);

	// Done!
	fclose(f);
	return true;
}

