
#include "StdAfx.h"
#include "make_gamma.h"
#include "write.h"
#include "illa/config.h"

bool CalcGamma(wchar_t* destFolder)
{
	FILE* f;
	if (_wfopen_s(&f, (std::wstring(destFolder) + L"/lut_gamma.h").c_str(), L"wb") != 0) return false;
	if (f == 0) return false;

	WriteStartGuard(f, "LUT_GAMMA_H");

	fprintf(f, "static const Byte c_gamma[%i][256]={\n", Img::MaxGamma - Img::MinGamma+1);

	for(int i = Img::MinGamma; i <= Img::MaxGamma; ++i)
	{
		fprintf(f, "\t");
		for(int j = 0; j < 256; ++j)
		{
			int val = static_cast<int>(255 * (pow(static_cast<float>(j) / 255.0f, (10.0f / static_cast<float>(i)))));
			fprintf(f, "%i, ", val);
		}
		fprintf(f, "\n");
	}
	fprintf(f, "};\n\n");

	WriteEndGuard(f);

	// Done!
	fclose(f);
	return true;
}
