#include "StdAfx.h"
#include "convert.h"

namespace Uni {
	std::wstring ConvertToWide(char* input) {
		COND_STRICT(input, Err::InvalidParam, TX("input was NULL."));

		if ((input[0] == 0xff) && (input[1] == 0xfe))
			return (wchar_t*)(input);
		else {
			size_t len=strlen(input);
			boost::scoped_array<wchar_t> dest(new wchar_t[len+1]);
			MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, input, static_cast<int>(len), dest.get(), static_cast<int>(len));
			return dest.get();
		}
	};

	std::wstring StripCarriageReturns(std::wstring input) {
		std::wstring ret;
		ret.reserve(input.length());

		size_t length=input.length();
		for(size_t i = 0; i < length; ++i)
			if(input[i] != L'\r') ret.push_back(input[i]);

		return ret;
	}

	std::string ConvertToUTF8(std::wstring input) {
		size_t len=input.length();
		boost::scoped_array<char> dest(new char[len+1]);
		WideCharToMultiByte(CP_UTF8, WC_COMPOSITECHECK, input.c_str(), static_cast<int>(len), dest.get(), static_cast<int>(len), 0, 0);
		return dest.get();
	}


	std::string ConvertToANSI(std::wstring input) {
		size_t len=input.length();
		boost::scoped_array<char> dest(new char[len+1]);
		WideCharToMultiByte(CP_ACP, WC_COMPOSITECHECK, input.c_str(), static_cast<int>(len), dest.get(), static_cast<int>(len), 0, 0);
		dest[len]=0;
		return dest.get();
	}
};
