

#include <vector>
#include <string>
#include <iostream>
#include <sstream>


namespace App {
	class TableParser {
	public:
		bool						Write();

		TableParser(const std::wstring input);
		~TableParser();

	private:
		enum OutputFormat {
			ANSI,
			UTF8,
			UTF16LE
		};

		static void					WriteString(std::wstring filename, std::wstring str, OutputFormat format);

	private:
		typedef std::vector<std::wstring>	StringContainer;
		StringContainer				m_enums;
		StringContainer				m_elements;

		struct OutFile {
			std::wstring			Filename;
			std::wstring			Name;
			OutputFormat			Format;

			void					Load(std::wstringstream& src) {
				std::wstring strFormat;
				std::getline(src, strFormat);
				Format=ANSI;
				if(strFormat==L"UTF-16LE") Format=UTF16LE;
				std::getline(src, Filename);
				std::getline(src, Name);
			}
		};

		OutFile						m_enum;
		OutFile						m_table;

		/*OutputFormat				m_outEnumFormat;
		std::wstring				m_outEnumName;
		std::wstring				m_outTableName;
		std::wstring				m_enumName;
		std::wstring				m_tableName;*/
		std::wstring				m_type;
	};
};
