#include "StdAfx.h"
#include "COM_PropertyHandlerFactory.h"


#include "dllmain.h"


IFACEMETHODIMP PropertyHandlerFactory::QueryInterface( REFIID riid, void **ppv )
{
	static const QITAB qit[] = {
		QITABENT(PropertyHandlerFactory, IClassFactory),
		{ 0 },
	};
	return QISearch(this, qit, riid, ppv);
}

IFACEMETHODIMP_(ULONG) PropertyHandlerFactory::AddRef()
{
	DllAddRef();
	return 2; // Object's lifetime is tied to the DLL, so no need to track its refcount
}

IFACEMETHODIMP_(ULONG) PropertyHandlerFactory::Release() 
{
	DllRelease();
	return 1; // Object's lifetime is tied to the DLL, so no need to track its refcount or manually delete it
}

IFACEMETHODIMP PropertyHandlerFactory::CreateInstance(IUnknown *pUnkOuter, REFIID riid, void **ppv)
{
	// Aggregation is not supported
	return pUnkOuter ? CLASS_E_NOAGGREGATION : PropertyHandlerFactory_CreateInstance(riid, ppv);
}

IFACEMETHODIMP PropertyHandlerFactory::LockServer(BOOL fLock)
{
	if (fLock)
	{
		DllAddRef();
	}
	else
	{
		DllRelease();
	}

	return S_OK;
}

//HRESULT PropertyHandlerFactory_CreateInstance( REFIID riid, void **ppv )
HRESULT PropertyHandlerFactory_CreateInstance( REFIID , void ** )
{
	//return PropertyHandlerFactory::CreateInstance(riid, ppv);
	return 0;
}