#ifndef CTHUMBPROVIDER_H
#define CTHUMBPROVIDER_H

#include "orz/file.h"
#include "illa/codec.h"
#include "illa/codecmgr.h"

class CPictusThumbnailProvider:public IInitializeWithStream, public IThumbnailProvider {
public:
	CPictusThumbnailProvider();

	virtual ~CPictusThumbnailProvider();

	// IUnknown
	IFACEMETHODIMP QueryInterface(REFIID riid, __deref_out void **ppv);

	IFACEMETHODIMP_(ULONG) AddRef();

	IFACEMETHODIMP_(ULONG) Release();    

	// IInitializeWithStream
	IFACEMETHODIMP Initialize(IStream *pStream, DWORD grfMode);

	// IThumbnailProvider
	IFACEMETHODIMP GetThumbnail(UINT cx, HBITMAP *phbmp, WTS_ALPHATYPE *pdwAlpha);

private:
	Img::Surface::Ptr LoadSurface(UINT cx);
	Img::AbstractCodec* FindCodec();

	Img::CodecFactoryStore m_cfs;

	long m_cRef;
	//IStream *m_pStream;
	IO::FileReader::Ptr m_reader;
};

HRESULT CPictusThumbnailProvider_CreateInstance(REFIID riid, __deref_out void **ppv);
#endif
