#include "StdAfx.h"
#include "assoc_mode.h"
#include "w32_reg.h"

namespace App {
	bool AssociationMode::IsAssociated(FileFormat::Ptr fmt) {
		return OnIsAssociated(fmt);
	}

	void AssociationMode::Associate(FileFormat::Ptr fmt) {
		return OnAssociate(fmt);
	}

	void AssociationMode::UnAssociate(FileFormat::Ptr fmt) {
		return OnUnAssociate(fmt);
	}

	void AssociationMode::DeleteDeprecatedAssociation(FileFormat::Ptr fmt) {
		OnDeleteDeprecatedAssociation(fmt);
	}

	void AssociationMode::BeginWriteProgIds(const String& name, const String& description) {
		COND_STRICT(!m_isWriting, Err::CriticalError, TX("Has already called BeginWriteProgIds"));
		m_isWriting = true;
		OnBeginWriteProgIds(name, description);
	}

	void AssociationMode::WriteProgId(FileFormat::Ptr fmt, const String& executable) {
		COND_STRICT(m_isWriting, Err::CriticalError, TX("BeginWriteProgIds has not been called."));
		COND_STRICT(!executable.empty(), Err::InvalidParam, TX("Executable was not set."));
		OnWriteProgId(fmt, executable);
	}

	void AssociationMode::EndWriteProgIds() {
		COND_STRICT(m_isWriting, Err::CriticalError, TX("BeginWriteProgIds has not been called."));
		m_isWriting = false;
		OnEndWriteProgIds();
	}

	AssociationMode::AssociationMode():m_isWriting(false) {}


	void AssociationMode::IsLaunchedThroughInstaller(bool yn) {
		m_isPriv = yn;
	}

	bool AssociationMode::IsLaunchedThroughInstaller() {
		return m_isPriv;
	}
}
