#ifndef ASSOC_MODE_H
#define ASSOC_MODE_H

#include "app_types.h"
#include "association_fileformat.h"

namespace App {
	class AssociationMode {
	public:
		void IsLaunchedThroughInstaller(bool yn);

		bool IsAssociated(FileFormat::Ptr fmt);
		void Associate(FileFormat::Ptr fmt);
		void UnAssociate(FileFormat::Ptr fmt);
		void DeleteDeprecatedAssociation(FileFormat::Ptr fmt);

		void BeginWriteProgIds(const String& name, const String& description);
		void WriteProgId(FileFormat::Ptr fmt, const String& executable);
		void EndWriteProgIds();

		virtual void DeleteGlobalData()=0;
		virtual void DeleteProgId(FileFormat::Ptr fmt)=0;

		virtual bool HasWrittenGlobalData()=0;
		virtual bool HasWrittenProgId(FileFormat::Ptr fmt)=0;
		virtual void Commit()=0;

		typedef boost::shared_ptr<AssociationMode> Ptr;

		AssociationMode();

	protected:
		bool IsLaunchedThroughInstaller();

	private:
		virtual bool OnIsAssociated(FileFormat::Ptr fmt)=0;
		virtual void OnAssociate(FileFormat::Ptr fmt)=0;
		virtual void OnUnAssociate(FileFormat::Ptr fmt)=0;
		virtual void OnDeleteDeprecatedAssociation(FileFormat::Ptr fmt)=0;
		virtual void OnBeginWriteProgIds(const String& name, const String& description)=0;
		virtual void OnWriteProgId(FileFormat::Ptr fmt, const String& executable)=0;
		virtual void OnEndWriteProgIds()=0;

		bool m_isWriting;
		bool m_isPriv;
	};
}

#endif
