#ifndef ASSOC_UTIL
#define ASSOC_UTIL

namespace Img {
	class CodecFactoryStore;
}

namespace App {
	namespace Association {
		enum Mode {
			AMUndefined,
			AMLegacyStandardUser,	// XP standard user, store everything in HKCU
			AMXP,
			AMVista,
		};
		void SetCodecFactoryStore(Img::CodecFactoryStore* cfs);
		void SetAssociationsMode(Mode m, bool isInstaller);

		bool HasSetupMachineLevelRegistry();
		void SetupMachineLevelRegistry();
		void DeleteMachineLevelRegistry();
		void DeleteDeprecatedAssociations();

		void AssociateAll();
		void AssociateNone();

		void Associate(size_t index, bool doSet);
		void Commit();
		bool IsAssociated(size_t index);
	};
}

#endif
