#include "StdAfx.h"
#include "association_fileformat.h"

namespace App {
	void FileFormat::AddExtension(const String& ext) {
		m_exts.push_back(ext);
	}

	String FileFormat::Identifier() const {
		COND_STRICT(!m_progId.empty(), Err::CriticalError, TX("Identifier was empty."));
		return m_progId;
	}

	String FileFormat::Description() const {
		COND_STRICT(!m_desc.empty(), Err::CriticalError, TX("Identifier was empty."));
		return m_desc;
	}

	DWord FileFormat::IconId() const {
		return m_iconId;
	}

	const FileFormat::ExtensionList& FileFormat::Extensions() const {
		return m_exts;
	}

	FileFormat::FileFormat(const String& progId, const String& desc, DWord iconId):m_progId(progId), m_desc(desc), m_iconId(iconId) {
		COND_STRICT(!m_progId.empty(), Err::CriticalError, TX("Identifier was empty."));
		COND_STRICT(!m_desc.empty(), Err::CriticalError, TX("Description was empty."));
	}
}
