#ifndef ASSOCIATION_FILEFORMAT_H
#define ASSOCIATION_FILEFORMAT_H

#include "app_types.h"

namespace App {
	class FileFormat {
	public:
		typedef std::deque<String> ExtensionList;

		void AddExtension(const String& ext);
		String Identifier() const;
		String Description() const;
		DWord IconId() const;

		const ExtensionList& Extensions() const;

		typedef boost::shared_ptr<FileFormat> Ptr;

		FileFormat(const String& progId, const String& desc, DWord icon);

	private:
		ExtensionList m_exts;

		String m_progId;
		String m_desc;
		DWord m_iconId;
	};
}

#endif
