#ifndef ASSOCIATION_INTERFACE_H
#define ASSOCIATION_INTERFACE_H

#include "association_fileformat.h"
#include "assoc_mode.h"

namespace App {
	class AssociationInterface {
	public:
		void Reset(const String& applicationName, const String& applicationDescription);
		void SetMode(AssociationMode::Ptr mode);
		void AddFileFormat(FileFormat::Ptr fmt);

		void Commit();

		bool IsFileFormatAssociated(FileFormat::Ptr fmt);
		void Associate(FileFormat::Ptr fmt);
		void UnAssociate(FileFormat::Ptr fmt);

		bool HasSetupMachineLevelRegistry();
		void SetupMachineLevelRegistry(const String& executable);
		void DeleteMachineLevelRegistry();
		void DeleteDeprecatedAssociations();

	private:
		typedef std::deque<FileFormat::Ptr> FormatList;
		FormatList m_formats;
		AssociationMode::Ptr m_mode;

		String m_appName, m_appDesc;
	};
}

#endif
