#ifndef COMMON_CONTROLS_H
#define COMMON_CONTROLS_H

#include "dialog.h"
#include "orz/intl.h"
#include "illa/codecmgr.h"
#include "ctrl_listview.h"

namespace App {
	class FileFormatsListView {
	public:
		enum {
			FileNameColumn=0,
			FileExtColumn=1
		};

	public:
		void UpdateStrings();
		void WriteAssociations();

		FileFormatsListView(Win::Dialog* pDialog, DWORD id, Img::CodecFactoryStore* cfs);

	private:
		Win::ListView* m_filetypes;
		Img::CodecFactoryStore* m_cfs;
		boost::signals2::connection m_lang;

	private:
		// Copies are not sane
		FileFormatsListView(const FileFormatsListView&);
		FileFormatsListView& operator=(const FileFormatsListView&);
	};
}

#endif
