#ifndef CTRL_EDITBOX_H
#define CTRL_EDITBOX_H

#include "control.h"
#include "orz/intl.h"

namespace Win {
	class EditBox:public Control {
	public:
		enum FilterCriteria {
			FilterNone,
			FilterInvalidFilename,
			FilterNotNumerical, 
		};

		void FilterChars(FilterCriteria criteria, int sidBalloonMessage=-1);

		String Text();
		void Text(const String& s);

	protected:
		// Block invalid construction
		EditBox(int id, HWND hwnd):Control(id, hwnd), m_balloonText(-1), m_criteria(FilterNone), m_prevEditWndProc(0) {}

		friend class BaseWindow;

	private:
		EditBox();

		bool isValidChar(Char c);
		void showBalloon(const String& str);

		// Sub classing
		FilterCriteria m_criteria;
		HWND m_hOriginal;
		int m_balloonText;
		WNDPROC m_prevEditWndProc;

		static LRESULT CALLBACK	FilterEditWndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);

	};
}

#endif
