#include "StdAfx.h"
#include "res_settings.h"
#include "dlg_filetypes.h"
#include "illa/codecmgr.h"
#include "res_viewer.h"
#include "common_controls.h"
#include "vista_filetypehandler.h"
#include "xp_filetypehandler.h"
#include "osinfo.h"
#include "assoc_util.h"

namespace App {
	namespace Set {
		using namespace Intl;

		bool Filetypes::PerformOnInitPage() {
			Caption(App::SIDFiletypes);
			ControlText(IDC_GROUP_FILETYPES_ASSOCIATIONS, SIDGroupFileTypes);
			ControlText(IDC_BUTTON_FILETYPES_LAUNCHDIALOG, SIDAssociationSetup);
			m_handler->OnInit(this);
			return true;
		}

		void Filetypes::onWriteSettings() {
			m_handler->OnWriteSettings();
		}

		Filetypes::Filetypes(Img::CodecFactoryStore* cfs):App::SettingsPage(IDD_SET_FILETYPES) {
			if (Win::GetWindowsVersion() >= Win::WindowsVista && Association::HasSetupMachineLevelRegistry())
				m_handler.reset(new FiletypeHandlerVista());
			else
				m_handler.reset(new FiletypeHandlerXP(cfs));
		}
	}
}
