#include "StdAfx.h"
#include "res_settings.h"
#include "dlg_language.h"
#include "registry.h"

namespace App {
	using namespace Reg::Keys;
	using namespace Intl;

	bool SetLanguage::PerformOnInitPage() {
		Caption(App::SIDLanguage);
		ControlText(IDC_GROUP_LANG, SIDLanguage);

		m_cbLang = CreateComboBox(IDC_COMBO_LANG);
		for (int i = 0; i < Intl::FinalLang; ++i)
			m_cbLang->AddItem(Intl::GetStringLang(SIDLanguageName, (Intl::Language)(i)), (Intl::Language)i);

		m_cbLang->SetSelection(Intl::CurrentLanguage());
		return true;
	}

	void SetLanguage::onWriteSettings() {
		Reg::Key(DWLanguage, m_cbLang->GetSelectionData());
		CurrentLanguage(Language(m_cbLang->GetSelectionData()));
	}

	SetLanguage::SetLanguage():App::SettingsPage(IDD_SET_LANGUAGE) {}
}
