#include "StdAfx.h"
#include "gdi_ddsurface.h"

namespace Win {
	void DDSurfaceGDI::OnCreate(const Geom::SizeInt& dims) {
		COND_STRICT(m_dc, Err::CriticalError, TX("HDC not set"));
		Deallocate();

		//m_hbm = CreateCompatibleBitmap(m_dc, dims.Width, dims.Height);
		BITMAPINFO bmi;
		ZeroMemory(&bmi, sizeof(bmi));
		bmi.bmiHeader.biSize = sizeof(bmi.bmiHeader);
		bmi.bmiHeader.biCompression = BI_RGB;
		bmi.bmiHeader.biPlanes = 1;
		bmi.bmiHeader.biWidth = dims.Width;
		bmi.bmiHeader.biHeight=-dims.Height;
		bmi.bmiHeader.biBitCount = 4 * 8;
		
		m_hbm = CreateDIBSection(m_dc, &bmi, 0, &m_data, 0, 0);
		m_blitDC.SelectObject(m_hbm);
	}

	DDSurfaceGDI::DDSurfaceGDI(HDC hdc):m_dc(hdc), m_hbm(0) {
		COND_STRICT(hdc, Err::InvalidParam, TX("HDC was null"));
	}

	DDSurfaceGDI::~DDSurfaceGDI() {
		Deallocate();
	}

	void DDSurfaceGDI::Deallocate() {
		if(m_hbm) {
			m_blitDC.UnselectObject();
			DeleteObject(m_hbm);
			m_hbm = 0;
		}
	}

	SharedDC& DDSurfaceGDI::GetDC() {
		return m_blitDC;
	}

	Byte* DDSurfaceGDI::GetWritePtr() {
		return static_cast<Byte*>(m_data);
	}
}
