#ifndef GDI_DDSURFACE_H
#define GDI_DDSURFACE_H

#include "w32_ddsurface.h"
#include "gdiwrapper.h"

namespace Win {
	class DDSurfaceGDI:public DDSurface, boost::noncopyable {
	public:
		SharedDC& GetDC();
		Byte* GetWritePtr();

		DDSurfaceGDI(HDC hdc);
		~DDSurfaceGDI();

		typedef boost::shared_ptr<DDSurfaceGDI> Ptr;

	private:
		void OnCreate(const Geom::SizeInt& dims);
		void Deallocate();

		HBITMAP m_hbm;
		HDC m_dc;
		SharedDC m_blitDC;
		void* m_data;
	};
}

#endif
