#include "StdAfx.h"
#include "ic_queue.h"

namespace Img {
	using boost::condition;
	using boost::mutex;
	using boost::shared_ptr;

	using std::deque;
	using std::list;
	using std::map;
	using std::vector;

	void ImageQueue::CacheImage(const ImageList& imagesToProcess) {
		boost::mutex::scoped_lock l(m_mxPackageList);
		m_workPackages = imagesToProcess;
	}

	void ImageQueue::RemoveImage(Image* image) {
		boost::mutex::scoped_lock l(m_mxPackageList);
		ImageList::iterator i = std::find(m_workPackages.begin(), m_workPackages.end(), image);
		if(i != m_workPackages.end())
			m_workPackages.erase(i);
	}

	void ImageQueue::Reset() {
		boost::mutex::scoped_lock l(m_mxPackageList);
		m_workPackages.clear();
	}

	Img::ImageList ImageQueue::GetImageList() {
		boost::mutex::scoped_lock l(m_mxPackageList);

		return m_workPackages;
	}
}
