#ifndef IMAGECACHE_FILEENTRY_H
#define IMAGECACHE_FILEENTRY_H

#include "illa/image.h"

namespace Img {
	namespace Internal {
		class FileEntry {
		public:
			Img::Image::Ptr Image();

			const String& Name() const;
			void Rename(const String& newName);

			FileInt DateModified();
			FileInt DateAccessed();
			FileInt DateCreated();
			FileInt FileSize();

			FileEntry(String fullname);

		private:
			void QueryFile();

			Img::Image::Ptr m_image;
			String m_fullname;
			bool m_hasQueriedFile;
			FileInt m_dateCreate;
			FileInt m_dateAccess;
			FileInt m_dateModified;
			FileInt m_fileSize;

		};
	}
}

#endif
