#ifndef MONITOR_H
#define MONITOR_H

#include "wintypes.h"

namespace Win {
	class Monitor {
	public:
		const Geom::RectInt& Region() const;
		const Geom::RectInt& WorkArea() const;

		Monitor(HMONITOR hMonitor);

	private:
		void refreshMonitorInfo();

		Geom::RectInt m_region;
		Geom::RectInt m_workArea;
		HMONITOR m_hMonitor;
	};

	const Monitor* FindMonitorAt(const Geom::PointInt& coordinate);
}

#endif
