#ifndef NOTIFICATION_H
#define NOTIFICATION_H

namespace Win {
	class Notification {
	public:
		enum BalloonStandardIcon {
			BSIError,
			BSIInfo,
			BSIWarning,
		};

		void Show(HWND hwndOwner);
		void Remove();

		void Icon(HICON icon);
		void ToolTip(const String& text);

		void Balloon(const String& text, const String& caption, DWORD msTimeout);

		void BalloonIcon(HICON icon);
		void BalloonIcon(BalloonStandardIcon icon);

		DWORD ID() const { return m_nid.uID; }

		Notification();
		~Notification();

	private:
		NOTIFYICONDATA m_nid;

		static boost::mutex m_mutexCounter;
		static DWORD m_idCounter;
	};
}

#endif
