#ifndef REG_PROGID_H
#define REG_PROGID_H

#include "w32_reg.h"
#include "association_fileformat.h"

namespace App {
	class ProgId {
	public:
		static void WriteProgId(FileFormat::Ptr fmt, const String& executable, bool writeInCurrentUser);
		static bool HasWrittenProgId(FileFormat::Ptr fmt, bool writeInCurrentUser);
		static void DeleteProgId(FileFormat::Ptr fmt, bool writeInCurrentUser);

		static bool IsAssociated(FileFormat::Ptr fmt);
		static void Associate(FileFormat::Ptr fmt);
		static void UnAssociate(FileFormat::Ptr fmt);
		static void DeleteDeprecatedAssociation(FileFormat::Ptr fmt);

	private:
		static void DoDeleteAssociation(FileFormat::Ptr, bool oldClasses);

		static Win::RegistryKey::Root DetermineRoot(bool writeInCurrentUser);
		static String DetermineClassesBase(bool writeInCurrentUser);
		static bool HasExtension(const String& progId, const String& ext);

	};
}

#endif
