#ifndef RENDERTARGETGDI_H
#define RENDERTARGETGDI_H

#include "w32_renderer.h"
#include "illa/surface.h"

namespace Win {
	class RendererGDI:public Renderer {
	public:
		Img::Surface::Ptr CreateSurface();

		typedef boost::shared_array<Byte> ByteArray;

	private:
		Geom::RectInt GetInvalidArea();
		bool PanCurrentView(const Geom::SizeInt& offset);
		Geom::SizeInt RenderAreaSize();

		RenderStatus OnBeginRender();

		DDSurface::Ptr OnCreateDDSurface();
		void OnRenderToDDSurface(DDSurface::Ptr dest, Img::Surface::Ptr source, const Geom::PointInt& zoomedImagePosition, const Geom::RectInt& destinationArea, const Img::Properties& props);
		void OnPresentFromDDSurface(const Geom::RectInt& destRect, DDSurface::Ptr source, const Geom::PointInt& sourceTopLeft);

		void OnEndRender();

		PAINTSTRUCT m_ps;
	};
}

#endif
