#include "StdAfx.h"
#include "timeconvert.h"

namespace App {
	FILETIME ToFILETIME(FileInt i) {
		FILETIME f;
		f.dwLowDateTime = i & 0xffffffff;
		f.dwHighDateTime = (i >> 32) & 0xffffffff;
		return f;
	}

	SYSTEMTIME ToSYSTEMTIME(FileInt date) {
		SYSTEMTIME st;
		FILETIME ft = ToFILETIME(date);
		FileTimeToSystemTime(&ft, &st);
		return st;
	}

	String FormattedDate(FileInt date) {
		SYSTEMTIME st = ToSYSTEMTIME(date);
		int len=GetDateFormat(LOCALE_USER_DEFAULT, 0, &st, 0, 0, 0);
		boost::scoped_array<Char> tmpStr(new Char[len]);
		GetDateFormat(LOCALE_USER_DEFAULT, 0, &st, 0, tmpStr.get(), len);
		return String(tmpStr.get());
	}

	String FormattedTime(FileInt date) {
		SYSTEMTIME st = ToSYSTEMTIME(date);
		int len=GetTimeFormat(LOCALE_USER_DEFAULT, TIME_NOSECONDS, &st, 0, 0, 0);
		boost::scoped_array<Char> tmpStr(new Char[len]);
		GetTimeFormat(LOCALE_USER_DEFAULT, TIME_NOSECONDS, &st, 0, tmpStr.get(), len);
		return String(tmpStr.get());
	}
}
