#include "StdAfx.h"
#include "timer.h"

namespace Win {
	Timer::TimerMap Timer::m_timers;

	VOID CALLBACK Timer::TimerCallback(HWND, UINT, UINT_PTR idEvent, DWORD) {
		TimerMap::iterator i = m_timers.find(idEvent);
		if(i != m_timers.end())
			(*i->second).OnTick();
	}

	void Timer::Create(int delay) {
		Destroy();
		m_timerId = SetTimer(0, 0, delay, Timer::TimerCallback);
		if(!m_timerId) return;

		m_timers[m_timerId] = this;
	}

	void Timer::Destroy() {
		if(!m_timerId) return;
		m_timers.erase(m_timerId);
		m_timerId = 0;
	}

	Timer::Timer():m_timerId(0) {}

	Timer::~Timer() {
		Destroy();
	}
}
