#ifndef TIMER_H
#define TIMER_H

namespace Win {
	class Timer:boost::noncopyable {
	public:
		boost::signals2::signal<void()> OnTick;

		void Create(int delay);
		void Destroy();

		Timer();
		~Timer();

	private:
		static VOID CALLBACK TimerCallback(HWND, UINT uMsg, UINT_PTR idEvent, DWORD dwTime);

		int m_timerId;

		typedef std::map<int, Timer*> TimerMap;
		static TimerMap m_timers;
	};
}

#endif
