#include "StdAfx.h"
#include "w32_assure_folder.h"
#include "io.h"
#include "orz/fileops.h"

String assure_folder(String name) {
	String path = IO::GetPath(name);
	String filename = IO::GetFile(name);

	// Always use the Application Data folder as a base
	Char sLoc[MAX_PATH];
	COND_STRICT(SUCCEEDED(SHGetFolderPath(0, CSIDL_APPDATA, 0, 0, sLoc)), Err::CriticalError, TX("Could not find settings directory."));

	String currentPath(sLoc);
	currentPath += TX("\\");

	// Create all sub directories one by one.
	size_t index	= 1;
	do {
		size_t newindex = path.find_first_of(TX("\\/"), index);
		if (newindex == String::npos) break;

		currentPath += path.substr(index, newindex - index + 1);
		CreateDirectory(currentPath.c_str(), 0);
		index = newindex;

		if (index != String::npos) ++index;
	}
	while (index != String::npos);

	return currentPath + filename;
}
