#include "StdAfx.h"
#include "app_types.h"
#include "main.h"
#include "wintypes.h"
#include "orz/fileops.h"

int WINAPI wWinMain(HINSTANCE, HINSTANCE, LPTSTR pCmdLine, int) {
	INITCOMMONCONTROLSEX icce;
	icce.dwSize = sizeof(icce);
	icce.dwICC = ICC_BAR_CLASSES | ICC_TREEVIEW_CLASSES | ICC_UPDOWN_CLASS | ICC_LISTVIEW_CLASSES;
	if (InitCommonControlsEx(&icce) == FALSE) {
		::MessageBox(0, TX("Couldn't initialize common controls."), 0, MB_OK);
		return EXIT_FAILURE;
	}

	HRESULT hret = CoInitializeEx(0, COINIT_APARTMENTTHREADED);
	if (FAILED(hret)) {
		::MessageBox(0, TX("CoInitializeEx failed.\nThis is bad."), 0, MB_OK);
		return EXIT_FAILURE;
	}

	TCHAR appPath[MAX_PATH];
	GetModuleFileName(0, appPath, sizeof(appPath) - 1);
	SetCurrentDirectory(IO::GetPath(appPath).c_str());

	int ret = start_app(Win::LongPath(pCmdLine));

	return ret;
}
