#ifndef WINTYPES_H
#define WINTYPES_H

#include "app_types.h"

namespace Win {
	enum MouseButton {
		NoButton,
		Left,
		Right,
		Middle,
		Extra1,
		Extra2
	};

	class MouseEvent {
	public:
		MouseButton Button;
		Geom::PointInt Position;
		int WheelTicks;

		MouseEvent():Button(Left), Position(0, 0), WheelTicks(0) {}
		MouseEvent(LPARAM lParam):Position((SHORT)LOWORD(lParam), (SHORT)HIWORD(lParam)), WheelTicks(0) { }
	};

	class KeyEvent {
	public:
		WPARAM Key;
		bool AltPressed;
		bool CtrlPressed;
		bool ShiftPressed;

		bool operator <(const KeyEvent& rhs) const;

		KeyEvent(WPARAM key, bool isAltPressed, bool isCtrlPressed, bool isShiftPressed);
	};

	String LongPath(const String& path);

	Geom::RectInt RECTToRect(const RECT& rect);
	RECT RectToRECT(const Geom::RectInt& rect);

	POINT PointToPOINT(const Geom::PointInt& point);
};

#endif
