#include "StdAfx.h"
#include "wiz_fileformats.h"
#include "res_viewer.h"
#include "assoc_util.h"

namespace App {
	namespace Wiz {
		void FileFormats::onInitPage() {
			SetCheckBox(IDC_RADIO_INSTALL_FORMATS_ALLFORMATS, true);
			ControlText(IDC_STATIC_INSTALL_FORMATS_DESC, SIDInstallFormatsDesc);
			ControlText(IDC_RADIO_INSTALL_FORMATS_ALLFORMATS, SIDInstallFormatsAll);
			ControlText(IDC_RADIO_INSTALL_FORMATS_NOCHANGE, SIDInstallFormatsNoChange);
			ControlText(IDC_RADIO_INSTALL_FORMATS_CUSTOM, SIDInstallFormatsCustom);
		}

		void FileFormats::writeSettings() {
			if (GetCheckBox(IDC_RADIO_INSTALL_FORMATS_ALLFORMATS))
				App::Association::AssociateAll();
			else if (GetCheckBox(IDC_RADIO_INSTALL_FORMATS_NOCHANGE))
			{
				// Nothing should be done, sweet!
			}
			else if (GetCheckBox(IDC_RADIO_INSTALL_FORMATS_CUSTOM))
			{
				// CustomFileFormats will do the work, nothing to be done here!
			}
			else DO_THROW(Err::CriticalError, TX("Invalid selection."));	// Should never occur
		}

		bool FileFormats::HideNext() {
			if (GetCheckBox(IDC_RADIO_INSTALL_FORMATS_CUSTOM)) return false;
			return true;
		}

		FileFormats::FileFormats() :Page(IDD_INSTALL_FORMATS) {}
	}
}
