#include "StdAfx.h"
#include "wiz_language.h"
#include "res_viewer.h"
#include "registry.h"

namespace App {
	namespace Wiz {
		void Language::onInitPage() {
			ControlText(IDC_STATIC_INSTALL_LANGUAGE_DESC, SIDInstallLanguageDesc);
			m_cbLang = CreateComboBox(IDC_COMBO_INSTALL_LANGUAGE_LANG);
			m_cbLang->OnSelectionChanged.connect(bind(&Language::ChangeLanguage, this));

			for (int i = 0; i < Intl::FinalLang; ++i)
				m_cbLang->AddItem(Intl::GetStringLang(SIDLanguageName, (Intl::Language)(i)), (Intl::Language)i);

			m_cbLang->SetSelection(Intl::SystemLanguage());
			Intl::CurrentLanguage(Intl::Language(m_cbLang->GetSelectionData()));
		}

		void Language::writeSettings() {
			Intl::Language lang = Intl::Language(m_cbLang->GetSelectionData());
			Intl::CurrentLanguage(lang);
			Reg::Key(Reg::Keys::DWLanguage, lang);
		}

		Language::Language():Page(IDD_INSTALL_LANGUAGE) {}

		void Language::ChangeLanguage() {
			Intl::CurrentLanguage(Intl::Language(m_cbLang->GetSelectionData()));
		}
	}
}
