

#ifndef BASICTHREAD_H
#define BASICTHREAD_H

#include <boost/thread.hpp>
#include <boost/shared_ptr.hpp>

#include "orz/thread.h"

class BasicThread
{
public:
	void							Run();
	void							Terminate();

	BasicThread();
	virtual ~BasicThread();

	typedef boost::shared_ptr<BasicThread> Ptr;

protected:
	bool							IsTerminating();
	void							Output(const String& s);

private:
	static void						threadWrapper(void* param);
	virtual void					ThreadMain();

	static size_t					m_idThreadCounter;
	boost::mutex					m_mutexTerm;
	size_t							m_id;
	bool							m_isTerminating;
	Util::ThreadPtr					m_thread;
};


#endif
