
#ifndef CACHEUSER_H
#define CACHEUSER_H

#include "imagecache.h"

#include "BasicThread.h"

class CacheUser
	:public BasicThread,
	 public Img::MessageReceiver

{
public:
	CacheUser(const String& folderA, const String& folderB)
		:m_pathA(folderA),
		 m_pathB(folderB),
		 m_isOnFirst(false)
	{}

private:
	struct CacheNotification
	{
		Img::MessageReceiver::LoadMessage message;
		String					desc;
	};

	typedef std::list<CacheNotification> NotificationList;
	NotificationList				m_notifications;
	boost::mutex					m_mutexNotifications;

	void							ThreadMain();

	void							SwitchFolder();

	void							OnLoadMessage(Img::MessageReceiver::LoadMessage s, Img::Image* pImage, const String& desc);

	CacheUser(const CacheUser& b);

	String							m_pathA;
	String							m_pathB;

	bool							m_isOnFirst;
	Img::Cacher						m_cacher;
};

#endif