#include "StdAfx.h"

#include "orz/folder.h"
#include "orz/file.h"

#include "FolderUser.h"


FolderUser::FolderUser(const String& folder)
	:m_folder(folder)
{}

FolderUser::~FolderUser() {}

void FolderUser::ThreadMain()
{
	Output(TX("Initializing FolderUser, scanning ") + m_folder + TX(" ..."));
	IO::Folder folder;

	folder.Path(m_folder);

	Output(TX("Init complete, running ..."));

	IO::FileList files = folder.CurrentContents();
	IO::FileList::iterator i = files.begin();

	while(IsTerminating() == false)
	{
		i++;
		if (i != files.end())
		{
			if (i->Type == IO::TypeFile)
			{
				String name = m_folder + i->Name;

				IO::FileReader file(name);
				if (file.Open())
				{
					Byte buf[4096];
					file.Read(buf, 1, 4096);
				}
			}
		}
		else
		{
			files = folder.CurrentContents();
			i = files.begin();
		}
	}
}
