#include "StdAfx.h"
#include "bmp_fileheader.h"
#include "types.h"

namespace Img {
	namespace Internal {
		void BMPFileHeader::Load(IO::FileReader::Ptr file) {
			enum {
				BITMAP_SIGN = 0x4D42,
			};

			file->Read(&type, 2, 1);
			file->Read(&size, 4, 1);
			file->Seek(4, IO::SeekMethodCurrent);	// Skip reserved bytes
			file->Read(&offset, 4, 1);

			// Validate
			COND_STRICT(type == BITMAP_SIGN, Err::InvalidHeader, TX("Magic bytes didn't match."));
			COND_STRICT(size <= file->Size(), Err::InvalidHeader, TX("File seems to be truncated."));
		}

		BMPFileHeader::BMPFileHeader() {}
	}
}
