#ifndef BMP_HEADER_H
#define BMP_HEADER_H

#include "orz/file.h"
#include "types.h"

namespace Img {
	namespace Internal {
		class BMPHeader {
		public:
			enum Compress {
				CompressRGB = 0,
				CompressRLE8 = 1,
				CompressRLE4 = 2,
				CompressBitfields = 3,
			};

			void Load(IO::FileReader::Ptr file);
			BMPHeader();

			Geom::SizeInt Size;
			Word ColorDepth;
			bool FlipVertical;
			DWord Compression;
			int NumColors;

			DWord RedMask;
			DWord GreenMask;
			DWord BlueMask;

			DWord RedShiftRight;
			DWord GreenShiftRight;
			DWord BlueShiftRight;

			Byte ScanPadding;

			Img::Palette Palette;

		private:
			DWord calcShift(DWord mask);
		};
	}
}

#endif
