#ifndef C_FACTORY_H
#define C_FACTORY_H

#include "types.h"

namespace Img {
	class AbstractCodec;

	class ICodecFactory {
	public:
		typedef std::vector<String>	ExtensionList;

	public:
		const ExtensionList& SupportedExtensions() const;

		const String& GetFormatName() const;

		virtual AbstractCodec* CreateCodec()=0;

		ICodecFactory(const String& name):m_name(name) {}
		virtual ~ICodecFactory() {}

	protected:
		void AddExtension(const String& extension);

	private:
		ExtensionList m_extensions;
		String m_name;
	};
}

#endif
