#ifndef C_PCX_H
#define C_PCX_H

#include "orz/file_cache.h"
#include "codec_static.h"
#include "pcx_header.h"

namespace Img {
	class Surface;

	class CodecPCX:public StaticCodec {
		bool PerformLoadHeader(IO::FileReader::Ptr file, ImageInfo& info);

		Img::Format determineSurfaceFormat( Byte colorDepth );
		AllocationStatus PerformAllocate();
		LoadStatus PerformLoadImageData(IO::FileReader::Ptr file);

		void transferNonPlanar( Byte* destination, Byte* source );
		void transferPlanar( Byte* destination, Byte* source );

		void transferPlanar4( Byte* destination, Byte* source );
		void transferPlanar38( Byte* destination, Byte* source );

		enum {
			ChunkRows				= 64,
		};

		void DecodeScanline(IO::FileReader::Ptr file, Byte* pDest, size_t maxBytes);

		Internal::PCXHeader m_header;
		int m_currScan;
		IO::FileReaderByteStreamer m_cache;
	};
}

#endif
