#ifndef C_TIFF_H
#define C_TIFF_H

#include "codec_static.h"
#include "types.h"

#include "tiff_loader.h"

namespace Img {
	class CodecTIFF:public StaticCodec {
	public:
		CodecTIFF();
		~CodecTIFF();

	private:
		bool PerformLoadHeader(IO::FileReader::Ptr file, ImageInfo& info);
		AllocationStatus PerformAllocate();
		LoadStatus PerformLoadImageData(IO::FileReader::Ptr file);

	private:
		void endImageIO();

	private:
		TIFF* m_tiff;
		Word m_photometric;

		TiffLoader::Ptr m_loader;
		TiffDataConverter::Ptr m_converter;

		Img::Palette m_palette;
	};
}

#endif
