#ifndef C_XYZ_H
#define C_XYZ_H

#include "codec_static.h"
#include "orz/file.h"

namespace Img {
	class CodecXYZ:public StaticCodec {
	public:
		CodecXYZ();
		~CodecXYZ();

	private:
		bool PerformLoadHeader(IO::FileReader::Ptr file, ImageInfo& info);
		AllocationStatus PerformAllocate();
		LoadStatus PerformLoadImageData(IO::FileReader::Ptr file);

	private:
		bool FillBuffer(IO::FileReader::Ptr file);

		void Cleanup();
		enum {
			InBufferSize = 256,
			OutBufferSize = 1024
		};

		Geom::SizeInt m_size;
		bool m_paletteSet;

		z_stream m_stream;

		Byte m_inBuffer[InBufferSize];

		typedef std::deque<Byte> ByteStream;
		ByteStream m_outData;
		int m_x, m_y;
		bool m_isInit;
	};
}

#endif
