#ifndef COLOR_IO_H
#define COLOR_IO_H

#include "orz/file.h"
#include "types.h"

namespace Img {
	Img::Color LoadRGB(IO::FileReader& file);
	Img::Color LoadBGR(IO::FileReader& file);
	Img::Color LoadBGRA(IO::FileReader& file);
	Img::Color LoadBGRX(IO::FileReader& file);

	template <class Fn>
	void LoadPalette(Img::Palette& pal, IO::FileReader& file, unsigned firstEntry, unsigned numEntries, Fn func) {
		COND_WARNING((firstEntry + numEntries) <= 256, Err::InvalidParam, TX("Color count out of bounds (> 255)"));
		COND_WARNING(firstEntry >= 0, Err::InvalidParam, TX("Color count out of bounds (< 0)"));

		for(unsigned i = 0; i < numEntries; i++) {
			pal.Color(firstEntry + i, func(file));
		}
	}
}

#endif
