#include "StdAfx.h"

#include "filter.h"

namespace Filter {
	namespace Alpha {
		void Alpha::PremultiplyAlphaBuffer(const FilterBuffer& source) {
			COND_STRICT(source.BufferData != 0, Err::InvalidParam, TX("Null buffer not allowed."));

			Byte* sourceCurrentScanlinePtr = source.BufferData;

			for (int y = 0;y < source.Dimensions.Height; ++y) {
				DWord* sourceCurrentPixelPtr = reinterpret_cast<DWord*>(sourceCurrentScanlinePtr);

				for(int x = 0; x < source.Dimensions.Width; ++x) {
					DWord&	sp = *sourceCurrentPixelPtr;
					Byte	sa = Img::ChannelARGB8888Alpha(sp);

					*(sourceCurrentPixelPtr++) = Img::ToARGBDWORD(
						sa,
						(Img::ChannelARGB8888Red(sp) * sa) / 0xff,
						(Img::ChannelARGB8888Green(sp) * sa) / 0xff,
						(Img::ChannelARGB8888Blue(sp) * sa) / 0xff);
				}
				sourceCurrentScanlinePtr += source.Stride;
			}
		}
	}
}
