#include "StdAfx.h"

#include "filter.h"

namespace Filter {
	namespace Alpha {
		void Alpha::SetAlpha(const FilterBuffer& source, int alpha) {
			COND_STRICT(source.BufferData != 0, Err::InvalidParam, TX("Null buffer not allowed."));

			Byte* sourceCurrentScanlinePtr = source.BufferData;
			DWord alphaComponent = alpha << 24;

			for (int y = 0;y < source.Dimensions.Height; ++y) {
				DWord* sourceCurrentPixelPtr = reinterpret_cast<DWord*>(sourceCurrentScanlinePtr);

				for(int x = 0; x < source.Dimensions.Width; ++x) {
					DWord&	sp = *sourceCurrentPixelPtr;
					*(sourceCurrentPixelPtr++) = (sp & 0x00ffffff) + alphaComponent;
				}
				sourceCurrentScanlinePtr += source.Stride;
			}
		}
	}
}
