#include "StdAfx.h"

#include "surface_lock_swmr.h"

namespace Img {
	using boost::condition;
	using boost::mutex;

	LockStrategySingleWriterMultipleReaders::LockStrategySingleWriterMultipleReaders()
		:m_isWriteLocked(false)
	{}

	void LockStrategySingleWriterMultipleReaders::onAcquireLock( LockMethod method ) {
		if(method == LockReadWrite) {
			mutex::scoped_lock l(m_mutexLocks);
			while(m_isWriteLocked == true)
				m_conditionUnlock.wait(l);

			m_isWriteLocked = true;
		}
	}

	void LockStrategySingleWriterMultipleReaders::onReleaseLock( LockMethod method ) {
		if(method == LockReadWrite) {
			mutex::scoped_lock l(m_mutexLocks);

			COND_WARNING(m_isWriteLocked, Err::CriticalError, TX("Attempted to write-unlock a lock which wasn't write locked."));
			m_isWriteLocked = false;
			m_conditionUnlock.notify_all();			
		}
	}
}
