#ifndef SWSURFACE_H
#define SWSURFACE_H

#include "surface.h"
#include "surfacefactory.h"

namespace Img {
	class SurfaceSoftware:public Img::Surface {
	public:
		Byte* DeviceIndependentData();

		SurfaceSoftware();

		typedef boost::shared_ptr<SurfaceSoftware> Ptr;

	private:
		void onDeallocate();
		bool onCreateSurface();

		unsigned char* onLockSurface(const Geom::RectInt& region, Img::LockMethod method = Img::LockReadWrite);
		void onUnlockSurface();
		void onPaletteUpdate();
		size_t onStride() const;

		boost::shared_array<Byte> m_pDIData;
	};

	class FactorySurfaceSoftware:public Img::ISurfaceFactory {
	public:
		Img::Surface::Ptr CreateSurface() { return Surface::Ptr(new SurfaceSoftware); }
	};
}

#endif
