#ifndef TIFF_CONVERTER_H
#define TIFF_CONVERTER_H

#include "types.h"

namespace Img {
	class TiffDataConverter {
	public:
		void Create(TIFF* tiff, Format dataFormat);

		Byte* RequestDestinationBuffer(size_t bytes);
		Byte* ReleaseDestinationBuffer(int widthInPixels, size_t bytesUsed, size_t* expandedSize);

		virtual ~TiffDataConverter();

		typedef boost::shared_ptr<TiffDataConverter> Ptr;

	protected:
		TIFF* m_tiff;
		Format m_format;

	private:
		virtual void PerformCreate();
		virtual Byte* PerformRequestDestinationBuffer(size_t bytes)=0;
		virtual Byte* PerformReleaseDestinationBuffer(int widthInPixels, size_t bytesUsed, size_t* expandedSize)=0;
	};
}

#endif
