#ifndef ALGO_H
#define ALGO_H

namespace orz {
	template <class _FwdIt>
	inline _FwdIt s_unique(_FwdIt first, _FwdIt last) {
		typedef std::iterator_traits<_FwdIt>::value_type ValueType;
		typedef std::set<ValueType> Erasable;

		std::set<ValueType> encountered;
		std::set<_FwdIt> to_erase;

		for(_FwdIt i=first; i != last; i++) {
			if(encountered.find(*i) != encountered.end())
				to_erase.insert(i);
			else
				encountered.insert(*i);
		}

		_FwdIt readPos = first;
		for(_FwdIt i=first; i != last; i++) {
			while(readPos != last && to_erase.find(readPos) != to_erase.end())
				readPos++;
			if(readPos == last)
				return i;
			*i = *readPos;
			readPos++;
			if(readPos == last)
				return last;

		}
		return last;
	}
}

#endif
