#ifndef EXCEPTION_H
#define EXCEPTION_H

namespace Err {
	struct Exception {
		Exception(const String& msg):m_message(msg) {}
		virtual ~Exception() {}

		const String& Desc() const {
			return m_message;
		}

	private:
		String				m_message;
	};

	struct Unsupported:public Exception {
		Unsupported(const String& msg):Exception(TX("Unsupported operation: ")+msg) {}
	};

	struct DuplicateInstance:public Exception {
		DuplicateInstance():Exception(TX("DuplicateInstance")) {}
	};

	struct CriticalError:public Exception {
		CriticalError(const String& msg):Exception(TX("Critical error: ")+msg) {}
	};

	struct InvalidCall:public Exception {
		InvalidCall(const String& msg):Exception(TX("Invalid call: ") + msg) {}
	};

	struct InvalidParam:public Exception {
		InvalidParam(const String& msg):Exception(TX("Invalid param: ")+msg) {}
	};

	struct NotYetImplemented:public Exception {
		NotYetImplemented(const String& msg):Exception(TX("Not yet implemented:") + msg) {};
	};
}

#endif
