#ifndef FOLDER_H
#define FOLDER_H

#include "folder_imp.h"
#include "folder_iterator.h"

namespace IO {
	class Folder:boost::noncopyable {
	public:
		bool Path(const String& filename);
		String Path() const;

		FolderFileIterator::Ptr CreateIterator() const;
		IO::FileList CurrentContents() const;

		Folder();

	private:
		FolderImplementation* doCreateImp(const String& path);

	private:
		mutable boost::mutex m_mxCall;
		FileList m_content;

		std::auto_ptr<FolderImplementation>	m_imp;
	};
}

#endif
