#ifndef INTL_H
#define INTL_H

namespace Intl {
	enum Language {
		LangEnglish = 0,
		LangSwedish,
		FinalLang,
	};

	struct TableEntry {
		const Char*					langs[FinalLang];
	};

	void LanguageTable(const TableEntry* pTable, int minID, int maxID);
	void CurrentLanguage(const Language& lang);
	const Language CurrentLanguage();
	Language SystemLanguage();
	const Char* GetString(int id);
	const Char* GetStringLang(int id, Language lang);

	extern boost::signals2::signal<void()> OnLanguageChanged;
};

#endif
