#include "StdAfx.h"
#include "logger.h"

namespace IO {
	void Logger::SetOutput(const String& filename) {
		m_filename = filename;
		m_wroteBOM = false;
		AttemptInitialize();
	}

	void Logger::Write(const String& message) {
		AttemptInitialize();
		IO::FileWriter f;
		if(!f.Open(m_filename, true))
			return;  // Prefer losing logging messages than raising an error.
		f.Write(message.c_str(), 2, message.length());
	}

	void Logger::AttemptInitialize() {
		if(m_wroteBOM) return;
		IO::FileWriter f;
		if(!f.Open(m_filename)) return;
		const unsigned char bof[2] = {0xff, 0xfe};
		f.Write(bof, 1, 2);
		m_wroteBOM = true;
	}

	String Internal::Cleanup(const String& input) {
		String output(input);

		size_t pos = 0;
		while((pos = output.find(TX("\n"), pos)) != String::npos) {
			output.insert(pos, TX("\r"));
			pos += 2;
		}
		return output;
	}
}
