#ifndef LOGGER
#define LOGGER

#include "file.h"

namespace IO {
	class Logger {
	public:
		void SetOutput(const String& filename);

	private:
		void Write(const String& message);
		void AttemptInitialize();
		String m_filename;
		bool m_wroteBOM;

		template <typename T> friend 
			Logger& operator <<(Logger& log, T const& value);
	};

	namespace Internal {
		String Cleanup(const String& input);
	}

	template <typename T>
	Logger& operator <<(Logger& log, T const& value) {
		StringStream ss;
		ss << value;

		log.Write(Internal::Cleanup(ss.str()));
		return log;
	}
}

#endif
