#ifndef ORZ_MATH_H
#define ORZ_MATH_H

namespace Math {
	class Randomizer {
	public:
		void Seed(DWord seed);
		void SeedTimer();

		unsigned long Random();

		Randomizer();
		Randomizer(DWord seed);

	private:
		void RecalcMersenneSet();

		enum {
			NumbersPerBatch = 624,
			SomeConst		= 397,
			BitMask32		= 0xffffffffUL,
			TopBit			= 0x80000000UL,
			LowerBits		= 0x7fffffffUL
		};

		unsigned long m_mersenne[NumbersPerBatch];
		int m_currIndex;
		static const unsigned long GenSwitch[2];
	};

	namespace Bit {
		inline int CountSet(DWord u) {
			DWord uCount = u - (((u >> 1) & 033333333333) + ((u >> 2) & 011111111111));
			return ((uCount + (uCount >> 3)) & 030707070707) % 63;
		}
 	}

	int Lerp(float t, int a, int b);
}

#endif
