#ifndef STREAM_FILE_H
#define STREAM_FILE_H

#include "stream.h"

namespace IO {
	class StreamFile:public Stream {
	public:
		StreamFile(const String& filename);
		~StreamFile();

#ifdef WIN32
		String Rename(const String& newFilename, HWND handle);
		void Renamed(const String& newFilename);
		bool Delete(bool doRecycle, HWND handle);
#endif

	private:
		String performName() const;
		bool performOpen();
		bool performIsOpen() const;
		void performClose();
		size_t performRead(void* buf, size_t size, size_t items);
		void performSeek(FileInt position, SeekMethod m);
		FileInt performPosition() const;
		FileInt performSize();

		mutable boost::recursive_mutex m_mutexAccess;

		std::FILE* m_file;
		String m_name;
		FileInt m_size;
		OpenErrorCode m_error;
	};
}

#endif
