#ifndef STREAM_MEM_H
#define STREAM_MEM_H

#include "stream.h"

namespace IO {
	class StreamMemory:public Stream {
	public:
		StreamMemory(Byte* buffer, size_t size);

	private:
		String performName() const;
		bool performOpen();
		bool performIsOpen() const;
		void performClose();
		size_t performRead(void* buf, size_t size, size_t items);
		void performSeek(FileInt position, SeekMethod m);
		FileInt performPosition() const;
		FileInt performSize();

		mutable boost::recursive_mutex m_mutexAccess;

		Byte* m_data;
		FileInt m_size;
		FileInt m_pos;
		bool m_isOpen;
	};
}

#endif
