#ifndef STREAMWIN_H
#define STREAMWIN_H

#include "stream.h"

namespace IO {
	class StreamWindows:public Stream {
	public:
		StreamWindows(IStream* i);
		StreamWindows(const String& filename);
		~StreamWindows();

	private:
		String performName() const;
		bool performOpen();
		bool performIsOpen() const;
		void performClose();
		size_t performRead(void* buf, size_t size, size_t items);
		void performSeek(FileInt position, SeekMethod m);
		FileInt performPosition() const;
		FileInt performSize();

		IStream* m_pStream;
	};
}

#endif
