#ifndef STREAMCONV_H
#define STREAMCONV_H

namespace Util {
	class StreamConverter {
	public:
		void AddByte(const Byte b);
		bool AddBytes(const Byte* pBuf, size_t bufSize);

		int GetWord();

		int GetWordMsbToLsb();

		bool GetWordsAsByte(Byte* pDest, size_t num);

		bool GetWordsAsByteMsbToLsb(Byte* pDest, size_t num);

		unsigned int CurrentWordSize() const;

		void ChangeWordSize(unsigned int newBitCount);

		bool IsWordsLeft() const;

		StreamConverter(Byte destBitCount = 8);

	private:
		typedef std::deque<Byte> ByteStream;
		ByteStream m_source;
		unsigned int m_wordSize;
		size_t m_srcPos;
	};
}

#endif
