#include "StdAfx.h"
#include "sysinfo.h"

namespace Sys {
	namespace Info {
		class WinSysInfo {
		public:
			WinSysInfo() {
				ZeroMemory(&info, sizeof(info));
				GetSystemInfo(&info);
			}

			SYSTEM_INFO info;
		};

		WinSysInfo g_sysinfo;

		size_t TotalPhysicalMemory() {
			MEMORYSTATUS stat;
			GlobalMemoryStatus(&stat);
			return stat.dwTotalPhys;
		}

/*
		bool InstructionSet(CPUSet set) {
			int cpuinfo[4];

			__cpuid(cpuinfo, 1);

			switch(set) {
				case CPUMMX:
					return (cpuinfo[3] & 0x800000) != 0;
				case CPUSSE:
					return (cpuinfo[3] & 0x2000000) != 0;
				case CPUSSE2:
					return (cpuinfo[3] & 0x4000000) != 0;
				case CPUSSE3:
					return (cpuinfo[2] & 0x01) != 0;
			}
			return false;
		}
*/
		Intl::Language SystemLanguage() {
			switch(GetUserDefaultUILanguage()) {
				case 0x041d:
					return Intl::LangSwedish;
				/*case 0x0411:
					return Intl::LangJapanese;*/
				default:
					return Intl::LangEnglish;
			}
		}

		const String ExePath() {
			Char strExe[MAX_PATH];
			::GetModuleFileName(0, strExe, (sizeof(strExe) / sizeof(Char)) - 1);
			return strExe;
		}

		size_t ProcessorCount() {
			return Util::Max<size_t>(1, g_sysinfo.info.dwNumberOfProcessors);
		}
	}
}
