#ifndef THREADPOOL
#define THREADPOOL

#include "thread.h"

namespace Util {
	class Threadpool:boost::noncopyable {
	public:
		typedef boost::function<void()> Task;
		void AddTask(Task func);
		void JoinAll();

		Threadpool(size_t numThreads);
		~Threadpool();

	private:
		void Worker();

		boost::mutex m_mxTasks;
		boost::condition m_cdWorkAvail;
		boost::condition m_cdIdle;
		std::list<Task> m_tasks;
		std::vector<ThreadPtr> m_threads;
		bool m_terminate;
		size_t m_numRunning;
	};
}

#endif
