#include "StdAfx.h"

int RoundCast(float rhs) {
	return static_cast<int>(rhs + 0.5f);
}

bool IsDecimal(const String& s) {
	StringStream iss(s);
	int i;
	return !(iss >> std::dec >> i).fail();
}

String ToUpper(const String& s) {
	String b(s);
	std::transform(b.begin(), b.end(), b.begin(), std::towupper);
	return b;
}

String ToLower(const String& s) {
	String b(s);
	std::transform(b.begin(), b.end(), b.begin(), std::towlower);
	return b;
}

String UTF8ToString(const char* utf8) {
	int requiredBufferSizeInWChars = MultiByteToWideChar(CP_UTF8, 0, utf8, static_cast<int>(strlen(utf8) + 1), 0, 0);

	scoped_array<WChar> destinationBuffer(new WChar[requiredBufferSizeInWChars]);

	MultiByteToWideChar(CP_UTF8, 0, utf8, static_cast<int>(strlen(utf8) + 1), destinationBuffer.get(), requiredBufferSizeInWChars);
	return String(destinationBuffer.get());
}

String ToString( DWord i ) {
	StringStream ss;
	ss << i;
	return ss.str();
}

String ToString( int i ) {
	StringStream ss;
	ss << i;
	return ss.str();
}

String ToString( Byte i ) {
	StringStream ss;
	ss << i;
	return ss.str();
}

String ToString( const char* i ) {
	StringStream ss;
	ss << i;
	return ss.str();
}

String DoThrowBuildDescription(Char* filename, int lineNum, Char* functionName, String description) {
	return TX("\nFile: ") + ::String(filename) + TX("\nLine: ") + ::ToString(lineNum) + TX("\nFunction: ") + ::String(functionName) + TX("\n\nDescription: ") + description;
}

AString ToAString( String s ) {
	return AString(s.begin(), s.end());
}
