#include "StdAfx.h"
#include "w32_folder.h"
#include "w32_folder_iterator.h"
#include "folder.h"

namespace IO {
	FolderImplementation* Folder::doCreateImp(const String& path) {
		return new FolderWin32(path);
	}

	FolderWin32::FolderWin32(const String& path):FolderImplementation(SetFolderSlashes(path)) {}

	FolderFileIterator::Ptr FolderWin32::CreateIterator() {
		return FolderFileIterator::Ptr(new FolderFileIteratorWin32(Path()));
	}

	String FolderWin32::SetFolderSlashes(const String& inPath) {
		Char trm = *inPath.rbegin();
		if(trm != TX('\\') && trm != TX('/'))
			return inPath + TX("\\");
		return inPath;
	}
}
