#include "StdAfx.h"
#include "w32_folder_iterator.h"

namespace IO {
	bool FolderFileIteratorWin32::OnStep() {
		if(m_first) {
			m_first = false;
			return true;
		}

		return(FindNextFile(m_handle, &m_currentEntry) != 0);
	}

	FolderEntry FolderFileIteratorWin32::OnCurrentEntry() {
		FolderEntryType type(TypeFile);
		String name(m_currentEntry.cFileName);

		if (name == TX(".") || name == TX(".."))
			type = TypeDotFolder;
		else if (m_currentEntry.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
			type = TypeFolder;

		FolderEntry currentEntry = {m_currentEntry.cFileName, type};
		return currentEntry;
	}

	FolderFileIteratorWin32::FolderFileIteratorWin32(const String& path):m_handle(0), m_first(true) {
		m_handle = FindFirstFile((path + TX("*.*")).c_str(), &m_currentEntry);
		COND_STRICT(m_handle != INVALID_HANDLE_VALUE, Err::InvalidParam, TX("Call to FindFirstFile failed. Path = ") + path);
	}

	FolderFileIteratorWin32::~FolderFileIteratorWin32() {
		if(m_handle)
			FindClose(m_handle);
	}
}
