#include "StdAfx.h"
#include "w32_folder_monitor.h"
#include "folder_monitor.h"

namespace IO {
	/*FolderMonitorImplementation* FolderMonitor::doCreateImp(const String& path, ChangeEventCallback& ev) {
		return new FolderMonitorWin32(path, ev);
	}*/

	FolderMonitorWin32::FolderMonitorWin32(const String& path, ChangeEventCallback& ev)
		:FolderMonitorImplementation(path, ev), m_doTerminate(false), m_event(0)
	{
		String cropped = path.substr(0, path.length()-1);

		m_event = FindFirstChangeNotification(cropped.c_str(), false, FILE_NOTIFY_CHANGE_FILE_NAME | FILE_NOTIFY_CHANGE_DIR_NAME);

		COND_STRICT(m_event != INVALID_HANDLE_VALUE, Err::CriticalError, TX("Could not create a notification event."));
		COND_STRICT(m_event != 0, Err::CriticalError, TX("Could not create a notification event."));

		COND_STRICT(m_thread.get() == 0, Err::CriticalError, TX("Thread should NOT be running now!"));
		m_thread = Util::ThreadPtr(new boost::thread(Util::ThreadAdapter(&FolderMonitorWin32::threadWrapper, this)));
	}

	void FolderMonitorWin32::threadWrapper(void* param) {
		reinterpret_cast<FolderMonitorWin32*>(param)->ThreadMain();
	}

	void FolderMonitorWin32::ThreadMain() {
		while(!m_doTerminate) {
			DWORD dwWaitStatus = WaitForSingleObject(m_event, 100); 

			if (m_doTerminate) {
				//m_conditionTerminated.notify_all();
				break;
			}

			/*if(!PathIsDirectory(m_path.c_str())) {
				m_parent->OnFolderDeleted();
				m_isActive = false;
				m_conditionTerminated.notify_all();
				return;
			}*/

			switch(dwWaitStatus) {
			case WAIT_OBJECT_0:
				{
					//m_parent->OnActivity();

					FileEvent e;
					e.Path = Path();
					e.Type = FileAdded;
					e.Entry.Name = TX("test.tga");
					e.Entry.Type = TypeFile;
					OnEvent(e);

					FindNextChangeNotification(m_event);
				}
				break;
			}
		}
	}
}
