#ifndef W32_FOLDER_MONITOR_RDCW_H
#define W32_FOLDER_MONITOR_RDCW_H

#include "folder_monitor_imp.h"
#include "folder.h"
#include "thread.h"

namespace IO {
	class FolderMonitorWin32RDCW:public FolderMonitorImplementation {
	public:
		FolderMonitorWin32RDCW(const String& path, ChangeEventCallback& ev);
		~FolderMonitorWin32RDCW();

	private:
		static void threadWrapper(void* param);
		void ThreadMain();

		void ProcessNotification(PFILE_NOTIFY_INFORMATION currChange);

		String ExtractFilename(PFILE_NOTIFY_INFORMATION currChange);

		void FolderDeleted();

		enum {
			NumEvents = 4096
		};

		Byte m_changes[NumEvents * sizeof(FILE_NOTIFY_INFORMATION)];
		OVERLAPPED m_ol;

		HANDLE m_directory;
		Util::ThreadPtr m_thread;
		HANDLE m_ioComp;
		String m_oldName;
	};
}

#endif
