#include "StdAfx.h"
#include "orz/algo.h"

SUITE(Algos)
{
	TEST(StableUniqueSimple)
	{
		std::vector<String> StringList;
		StringList.push_back(TX("2. First String"));
		StringList.push_back(TX("1. Second String"));
		StringList.push_back(TX("1. Second String"));
		StringList.push_back(TX("1. Second String"));
		StringList.push_back(TX("1. Second String"));
		StringList.push_back(TX("3. Third String"));
		StringList.push_back(TX("1. Second String"));
		StringList.push_back(TX("2. First String"));
		StringList.push_back(TX("1. Second String"));
		StringList.erase(orz::s_unique(StringList.begin(), StringList.end()), StringList.end());
		CHECK_EQUAL(3, StringList.size());
		CHECK(TX("2. First String") == StringList[0]);
		CHECK(TX("1. Second String") == StringList[1]);
		CHECK(TX("3. Third String") == StringList[2]);
	}

	TEST(StableUniqueEmpty)
	{
		std::vector<String> StringList;
		StringList.erase(orz::s_unique(StringList.begin(), StringList.end()), StringList.end());
		CHECK_EQUAL(0, StringList.size());
	}

	TEST(StableUniqueAllUnique)
	{
		std::vector<String> StringList;
		StringList.push_back(TX("2. First String"));
		StringList.push_back(TX("1. Second String"));
		StringList.push_back(TX("3. Third String"));
		StringList.erase(orz::s_unique(StringList.begin(), StringList.end()), StringList.end());
		CHECK_EQUAL(3, StringList.size());
		CHECK(TX("2. First String") == StringList[0]);
		CHECK(TX("1. Second String") == StringList[1]);
		CHECK(TX("3. Third String") == StringList[2]);
	}

	TEST(StableUniqueSingle)
	{
		std::vector<String> StringList;
		StringList.push_back(TX("2. First String"));
		StringList.erase(orz::s_unique(StringList.begin(), StringList.end()), StringList.end());
		CHECK_EQUAL(1, StringList.size());
		CHECK(TX("2. First String") == StringList[0]);
	}

	TEST(StableUniqueAllSame)
	{
		std::vector<String> StringList;
		StringList.push_back(TX("2. First String"));
		StringList.push_back(TX("2. First String"));
		StringList.push_back(TX("2. First String"));
		StringList.push_back(TX("2. First String"));
		StringList.push_back(TX("2. First String"));
		StringList.push_back(TX("2. First String"));
		StringList.push_back(TX("2. First String"));
		StringList.erase(orz::s_unique(StringList.begin(), StringList.end()), StringList.end());
		CHECK_EQUAL(1, StringList.size());
		CHECK(TX("2. First String") == StringList[0]);
	}
}
