#include "StdAfx.h"

#include "orz/observer.h"

class TestSubject:public Util::Subject<TestSubject>
{
public:
	TestSubject():m_val(0) {}
	~TestSubject() {}

	int							Value() { return m_val; }
	void						Value(int i) { m_val = i; }

private:
	int							m_val;
};

class TestObserver:public Util::Observer<TestSubject>
{
public:
	void						ReferenceValue(int val)
	{
		m_doRef	= true;
		m_ref	= val;
	}

	TestObserver():m_doRef(false), Valid(true) {}
	~TestObserver() {}

	bool						Valid;

	void						Signal(TestSubject* pSub)
	{
		if((pSub == 0) || (m_doRef && (m_ref != pSub->Value()))) Valid = false;
	}

	bool						m_doRef;
	int							m_ref;
};

SUITE(Observer)
{
	TEST(Attach)
	{
		TestSubject s;
		TestObserver o;
		s.Attach(&o);
		o.ReferenceValue(20);
		s.Value(20);
		s.Detach(&o);
		CHECK(o.Valid);
	}


	TEST(Detach)
	{
		TestSubject s;
		TestObserver o;
		s.Attach(&o);
		o.ReferenceValue(10);
		s.Detach(&o);
		s.Value(20);
		CHECK(o.Valid);
	}
}
